<template>
  <div class="d-inline-flex">
    <b-dropdown
      id="dropdown-action"
      class="action-dropdown"
      variant="success"
      :text="$t('Action')"
    >
      <b-dropdown-group id="dropdown-action-new" :header="$t('New')">
        <b-dropdown-item-button @click="actions.createModalOpen = true">{{
          $t("Create")
        }}</b-dropdown-item-button>
        <b-dropdown-item-button @click="actions.importModalOpen = true">{{
          $t("Import")
        }}</b-dropdown-item-button>
      </b-dropdown-group>
      <b-dropdown-divider></b-dropdown-divider>
      <b-dropdown-group id="dropdown-action-edit" :header="$t('Edit')">
        <b-dropdown-item-button @click="actions.copyModalOpen = true">{{
          $t("Copy")
        }}</b-dropdown-item-button>
        <div id="extendButton">
          <b-dropdown-item-button
            :disabled="closed"
            @click="actions.extendModalOpen = true"
            >{{ $t("Extend") }}</b-dropdown-item-button
          >
        </div>
        <b-tooltip
          v-if="closed"
          target="extendButton"
          triggers="hover"
          noninteractive
          >{{ $t("mustNotBeClosed") }}</b-tooltip
        >
        <b-dropdown-item-button @click="actions.newVersionModalOpen = true">{{
          $t("NewVersion")
        }}</b-dropdown-item-button>
      </b-dropdown-group>
    </b-dropdown>
    <b-button
      v-if="authorizationModalExists"
      variant="secondary"
      @click="openAuthorizationModal"
      >{{ $t("EnterToken") }}</b-button
    >
    <ActionCopyModal
      :open="actions.copyModalOpen"
      @close="actions.copyModalOpen = false"
      @save="copyApplicationProfile"
    />
    <ActionCreateModal
      :open="actions.createModalOpen"
      @close="actions.createModalOpen = false"
      @save="createApplicationProfile"
    />
    <ActionImportModal
      :open="actions.importModalOpen"
      @close="actions.importModalOpen = false"
      @save="importApplicationProfile"
    />
    <ActionExtendModal
      :open="actions.extendModalOpen"
      @close="actions.extendModalOpen = false"
      @save="extendApplicationProfile"
    />
    <ActionNewVersionModal
      :open="actions.newVersionModalOpen"
      @close="actions.newVersionModalOpen = false"
      @save="newVersionApplicationProfile"
    />
    <template v-if="authorizationModalExists">
      <AuthorizationModal
        :open="authorizationModalOpen"
        @close="closeAuthorizationModal"
        @save="saveAuthorizationModal"
      />
    </template>
  </div>
</template>

<script lang="ts">
import type { ApplicationProfile } from "@/types/application-profile";
import type { Dataset } from "@rdfjs/types";

import factory from "rdf-ext";
import { initAPWithName, prefixes } from "@/util/linkedData";

import {
  copyApplicationProfileAction,
  extendApplicationProfileAction,
  newVersionApplicationProfileAction,
} from "@/util/actions/edit-actions";

import serviceProvider from "@/util/service-providers/service-provider";

import { defineComponent, type PropType } from "vue";

import { useMainStore } from "@/store";
import ApplicationProfileImpl from "@/classes/ApplicationProfileImpl";
import type DatasetExt from "rdf-ext/lib/Dataset";

import EmptyComponent from "@/components/Layout/EmptyComponent.vue";
const authorizationModalExists = serviceProvider.uiElements.AuthorizationModal
  ? true
  : false;
const AuthorizationModal = authorizationModalExists
  ? serviceProvider.uiElements.AuthorizationModal
  : EmptyComponent;

export default defineComponent({
  name: "ActivityActions",
  components: { AuthorizationModal },
  props: {
    applicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    definition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
  },
  setup() {
    const mainStore = useMainStore();

    return { mainStore };
  },
  data() {
    return {
      actions: {
        copyModalOpen: false,
        createModalOpen: false,
        extendModalOpen: false,
        importModalOpen: false,
        newVersionModalOpen: false,
      },
      authorizationModalExists: authorizationModalExists,
      authorizationModalOpen: false,
    };
  },
  computed: {
    closed(): boolean {
      if (this.applicationProfile.base_url) {
        for (const entry of this.definition.match(
          factory.namedNode(this.applicationProfile.base_url),
          factory.namedNode(prefixes.sh + "closed"),
        )) {
          return entry.object.value === "true";
        }
      }
      return false;
    },
  },
  mounted() {
    if (AuthorizationModal !== undefined && !serviceProvider.authorized()) {
      this.authorizationModalOpen = true;
    }
  },
  methods: {
    cloneApplicationProfile() {
      const applicationProfile = new ApplicationProfileImpl(
        this.applicationProfile.name,
        this.applicationProfile.base_url,
        {
          definition: this.applicationProfile.definition ?? "[]",
          mimeType: this.applicationProfile.mimeType,
        },
      );
      return applicationProfile;
    },
    cloneDefinition() {
      return (
        this.definition as unknown as DatasetExt
      ).clone() as unknown as Dataset;
    },
    closeAuthorizationModal() {
      this.authorizationModalOpen = false;
    },
    createApplicationProfile() {
      const applicationProfile = new ApplicationProfileImpl("", "", {
        definition: "[]",
        mimeType: "application/ld+json",
      });
      const definition = factory.dataset() as unknown as Dataset;
      initAPWithName(applicationProfile, definition, this.$i18n.locale);
      applicationProfile.definition = definition.toCanonical();
      applicationProfile.mimeType = "application/n-quads";
      this.mainStore.storeApplicationProfile(applicationProfile, definition);
      this.$emit("updateApplicationProfile", applicationProfile, definition);
      this.$emit("makeEditable");
      this.$emit("openEditModal");
    },
    copyApplicationProfile() {
      const applicationProfile = this.cloneApplicationProfile();
      const definition = this.cloneDefinition();
      copyApplicationProfileAction(applicationProfile, definition);
      this.$emit("updateApplicationProfile", applicationProfile, definition);
      this.$emit("makeEditable");
      this.$emit("openEditModal");
    },
    extendApplicationProfile() {
      const applicationProfile = this.cloneApplicationProfile();
      const definition = this.cloneDefinition();
      extendApplicationProfileAction(applicationProfile, definition);
      initAPWithName(applicationProfile, definition, this.$i18n.locale);
      this.$emit("updateApplicationProfile", applicationProfile, definition);
      this.$emit("makeEditable");
      this.$emit("openEditModal");
    },
    async importApplicationProfile(file: File, mimeType: string) {
      const fileString = await file.text();
      this.$emit("textDefinitionUpdate", fileString, mimeType);
    },
    newVersionApplicationProfile() {
      const applicationProfile = this.cloneApplicationProfile();
      const definition = this.cloneDefinition();
      newVersionApplicationProfileAction(applicationProfile, definition);
      this.$emit("updateApplicationProfile", applicationProfile, definition);
      this.$emit("makeEditable");
      this.$emit("openEditModal");
    },
    openAuthorizationModal() {
      this.authorizationModalOpen = true;
    },
    saveAuthorizationModal() {
      this.authorizationModalOpen = false;
      this.$emit("updateToken", serviceProvider.getToken());
    },
  },
});
</script>

<style scoped>
.action-dropdown .dropdown-menu {
  overflow-x: hidden !important;
}
</style>
